import pygame
from enum import Enum
from .Drawable import Drawable
import random

class Table(Drawable):

    def __init__(self, minX, maxX, minY, maxY, ratio):
        #call base class constructor
        Drawable.__init__(self, 0, 0, minX, maxX, minY, maxY, ratio)
        self.__order = []
        self.__status = Status.NotReady
        self.ilosc_klientow = random.randint(1,3)
        self.guest1 = self.getGuest()
        self.guest2 = self.getGuest()
        self.guest3 = self.getGuest()
        self.ksiazka = self.__loadImg('./images/ksiazka.png')
        self.stol = self.__loadImg('./images/stol.png')
        self.check = self.__loadImg('./images/check.png')
        self.plate = self.__loadImg('./images/plate.png')
        self.Offset = 100

    #sets table color based on it's status
    def getColor(self):
        color = None
        if self.__status == Status.NotReady:
            color = self.__loadImg('./images/stol.png')
        elif self.__status == Status.Ready:
            color = self.__loadImg('./images/kelner.png')
        elif self.__status == Status.Waiting:
            color = self.__loadImg('./images/kelner.png')
        elif self.__status == Status.Served:
            color = self.__loadImg('./images/kelner.png')
        return color

    def getGuest(self):
        guest = None
        i = random.randint(1,3)
        if i == 1:
            guest = self.__loadImg('./images/wiking_blond.png')
        elif i == 2:
            guest = self.__loadImg('./images/wiking_rudy.png')
        elif i == 3:
            guest = self.__loadImg('./images/wiking_rudy2.png')
        return guest

    def __loadImg(self, filePath):
        return pygame.transform.scale((pygame.image.load(filePath)),(140,140))

    def draw(self, screen):
        screen.blit(self.stol, (self.getX() * 100-20+self.Offset, self.getY() * 100-20+self.Offset))
        if self.ilosc_klientow == 1:
            screen.blit(self.guest1, (self.getX() * 100 - 20+self.Offset, self.getY() * 100 - 60+self.Offset))
        elif self.ilosc_klientow == 2:
            screen.blit(self.guest1, (self.getX() * 100 - 62+self.Offset, self.getY() * 100 - 60+self.Offset))
            screen.blit(self.guest2, (self.getX() * 100 - 20+self.Offset, self.getY() * 100 - 60+self.Offset))
        elif self.ilosc_klientow == 3:
            screen.blit(self.guest1, (self.getX() * 100 - 62+self.Offset, self.getY() * 100 - 60+self.Offset))
            screen.blit(self.guest2, (self.getX() * 100 - 20+self.Offset, self.getY() * 100 - 60+self.Offset))
            screen.blit(self.guest3, (self.getX() * 100 + 22+self.Offset, self.getY() * 100 - 60+self.Offset))

        if self.__status == Status.NotReady:
            screen.blit(self.ksiazka, (self.getX() * 100 - 20+self.Offset, self.getY() * 100 - 20+self.Offset))
        elif self.__status == Status.Ready:
            screen.blit(self.check, (self.getX() * 100 - 20+self.Offset, self.getY() * 100 - 20+self.Offset))
        elif self.__status == Status.Waiting:
            if self.ilosc_klientow == 1:
                screen.blit(self.plate, (self.getX() * 100 - 20+self.Offset, self.getY() * 100 - 20+self.Offset))
            elif self.ilosc_klientow == 2:
                screen.blit(self.plate, (self.getX() * 100 - 62+self.Offset, self.getY() * 100 - 20+self.Offset))
                screen.blit(self.plate, (self.getX() * 100 - 20+self.Offset, self.getY() * 100 - 20+self.Offset))
            elif self.ilosc_klientow == 3:
                screen.blit(self.plate, (self.getX() * 100 - 62+self.Offset, self.getY() * 100 - 20+self.Offset))
                screen.blit(self.plate, (self.getX() * 100- 20+self.Offset, self.getY() * 100 - 20+self.Offset))
                screen.blit(self.plate, (self.getX() * 100+ 22+self.Offset, self.getY() * 100 - 20+self.Offset))


    def setOrder(self, order):
        self.__order = order

    def getOrder(self):
        return self.__order

    def delOrder(self):
        self.setOrder([])

    def isStatus(self, status):
        return status == self.__status

    def setStatus(self, status):
        self.__status = status

#status of the table
class Status(Enum):
    NotReady = 0
    Ready    = 1
    Waiting  = 2
    Served   = 3