import pygame
from .Drawable import Drawable

class Waiter(Drawable):

    def __init__(self, x, y, minX, maxX, minY, maxY, ratio):
        #call base class constructor
        Drawable.__init__(self, x, y, minX, maxX, minY, maxY, ratio)
        self.__image = self.__loadImg('./images/kelner.png')
        self.__acceptedOrders = []
        self.Offset = 100


    def moveUp(self):
        if self.getY() > self.getMinY():
            self.setY(self.getY() - 1)
            return True
        else:
            return False

    def moveDown(self):
        if self.getY() < self.getMaxY():
            self.setY(self.getY() + 1)
            return True
        else:
            return False

    def moveLeft(self):
        if self.getX() > self.getMinX():
            self.setX(self.getX() - 1)
            return True
        else:
            return False

    def moveRight(self):
        if self.getX() < self.getMaxX():
            self.setX(self.getX() + 1)
            return True
        else:
            return False

    #accepts orders from the table and stores them in queue
    def addOrder(self, table):
        self.__acceptedOrders += [(table, table.getOrder())]

    def __loadImg(self, filePath):
        return pygame.transform.scale((pygame.image.load(filePath)),(140,140))

    def draw(self, screen):
        screen.blit(self.__image, (self.getX()*100-20+self.Offset, self.getY()*100-20+self.Offset))
